	;***********************
	; 8 bit chunky grey to *
	; 6 bitplanes grey     *
	; converter            *
	;                      *
	; Coyote 1996-09-16    *
	;***********************
	
	include	'e:\src\inc\equates.asm'
	include	'e:\src\inc\macros.asm'
	
clr_buf	macro
	clr	a
	rep	#6
	move	a,x:(r0)+
	endm
	
	;*** PROGRAM MEMORY ***
	
	ORG	P:$0
	jmp	<start
		
	ORG	P:$40
start	ori	#3,mr			; Disable IPL0, 1 and 2
	move	#0,omr			; Disable ROM
	movep	#1,x:<<PBC			; Turn on Host Port
	movep	x:<<HRX,x0			; Clear Host Port
	movep	#0,x:<<HCR			; Turn off XMT and RCV interrupts
		
	move	#<bit_buf,r0
	move	#6-1,m0
	move	r0,r1			; r0=load r1=store
	move	m0,m1
	move	r0,r2			; r2 is used by clear routine
	move	#8-1,m2			; Modulo 8 used by clear routine
	move	#HRX,r3
	move	#<rcv_buf,r4
	move	#16-1,m4
	
	move	#>8192,x0			; Shift constant
	move	#>2097152,x1		; Shift constant
	
	move	#>$424242,y1		; Synchronise with the CPU
	host_xmt	y1
	
forever	do	#8,get_pixels
	jclr	#0,x:<<HSR,*
	clr	b	x:(r3),y1
	mpy	x0,y1,a	b,x:(r2)+
	mpy	x1,y1,a	a1,y:(r4)+
	move	a1,y:(r4)+
get_pixels	
	do	#16,convert
	move	y:(r4)+,a
	lsr	a	x:(r0)+,b
	rol	b
	lsr	a	x:(r0)+,b	b,y1
	rol	b	y1,x:(r1)+
	lsr	a	x:(r0)+,b	b,y1
	rol	b	y1,x:(r1)+
	lsr	a	x:(r0)+,b	b,y1
	rol	b	y1,x:(r1)+
	lsr	a	x:(r0)+,b	b,y1
	rol	b	y1,x:(r1)+
	lsr	a	x:(r0)+,b	b,y1
	rol	b	y1,x:(r1)+
	move		b,x:(r1)+
convert	
	do	#6,send
	host_xmt	x:(r0)+
send	
	jmp	<forever
		
		
	;*** DATA ***
	
	ORG	X:$0
bit_buf	DSM	8			; 6 bitplan...
	
	ORG	Y:$0
rcv_buf	DSM	16
	
	
	
	END
