	;********************
	; GREYSCALE
	; INTERPOLATION     *
	;                   *
	; COYOTE 1996-10-12 *
	;                   *
	;********************
	
	INCLUDE	'e:\src\inc\equates.asm'
	INCLUDE	'e:\src\inc\macros.asm'

	;**** PROGRAM START ****
	
	ORG	P:$0
	jmp	<start
		
	ORG	P:$40

start	ori	#3,mr			; Disable IPL0, 1 and 2
	move	#0,omr			; Disable ROM
	movep	#1,x:<<PBC			; Turn on Host Port
	movep	x:<<HRX,x0			; Clear Host Port
	movep	#0,x:<<HCR			; Turn off XMT and RCV interrupts
	
	move	#HRX,r3
	
	host_xmt	x:magic			; Synchronise with 68030
	
again	host_rcv	x:rcv			; Number of pixels to recive
	host_rcv	x:xmt			; Number of pixels to transmit
	host_rcv	x0			; Number of scanlines
	host_rcv	a			; Recive constant (high)
	host_rcv	a0			; Recive constant (low)
	move	a10,l:<constant
	
	do	x0,no_lines
	
	clr	b			; Clear counter
	move	b,l:<counter
	
	move	#<ss,r4			; Get scanline
	do	x:<rcv,get_line
	host_rcv	y:(r4)+
get_line	
	
	move	#ds,r5
	
	move	l:<constant,a
	move	l:<counter,b
	
	add	a,b
	
	
	
	
crossed	
	
	
no_lines	
	
	jmp	<again
	
	
	;**** DATA ****
		
	ORG	X:$2
magic	DC	424242
rcv	DS	1
xmt	DS	1
	
	ORG	Y:$2
ss	DS	4096
ds	DS	4096
	
	ORG	L:$0
constant	DS	1
counter	DS	1
	
	END